unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Menus, shellapi;

type
  TformMenuPrincipal = class(TForm)
    txtProgramas: TComboBox;
    BNuevo: TButton;
    BIniciar: TButton;
    BParar: TButton;
    BInforme: TButton;
    THora: TTimer;
    BEliminar: TButton;
    BCerrar: TButton;
    LHora: TLabel;
    PopupMenu1: TPopupMenu;
    mnuPonerEncima: TMenuItem;
    mnuOcultar: TMenuItem;
    mnuMostrar: TMenuItem;
    BPrecio: TButton;
    txtInforme: TMemo;
    BOcultar: TButton;
    BGuardar: TButton;
    dlgGuardar: TSaveDialog;
    Label1: TLabel;
    LWEB: TLabel;
    procedure THoraTimer(Sender: TObject);
    procedure BNuevoClick(Sender: TObject);
    procedure BCerrarClick(Sender: TObject);
    procedure BIniciarClick(Sender: TObject);
    procedure BPararClick(Sender: TObject);
    procedure BInformeClick(Sender: TObject);
    procedure BEliminarClick(Sender: TObject);
    procedure mnuPonerEncimaClick(Sender: TObject);
    procedure RButtonUp;
    procedure FormDestroy(Sender: TObject);
    procedure mnuOcultarClick(Sender: TObject);
    procedure LButtonDblClk;
    procedure mnuMostrarClick(Sender: TObject);

    procedure insertarElementosLista();
    function eliminado (programa : string) : boolean;
    
    procedure BPrecioClick(Sender: TObject);
    procedure BOcultarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BGuardarClick(Sender: TObject);
    procedure LWEBClick2(Sender: TObject);

  protected
    procedure WndProc(var Msg: TMessage); override;
  public
    procedure NotifyTray(Command: Word; const Hint: string);
  private
    FTrayMessage: Cardinal;
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

uses unidadprocedimientos;
{$R *.dfm}
resourcestring
  STrayMessage = 'TemPro';

procedure TFormMenuPrincipal.insertarElementosLista();
var
  fichero : TextFile;
  ficheroExt, linea : string;
begin
  txtProgramas.Clear;
  ficheroExt := changefileext(paramstr(0),'.INI');
  if FileExists(ficheroExt) then
  begin
    AssignFile(fichero, ficheroExt);
    Reset(fichero);
    while not eof(fichero) do
    begin
      Readln(fichero, linea);
      if length(linea) > 1 then
        if (linea[1] = '[') and (length(linea) >= 3) then //si lleva [ ser un nombre de programa
          txtProgramas.Items.Add(Copy(linea, 2, Length(linea) - 2));  //quitar los []
    end;
    CloseFile(fichero);
  end;
end;

procedure TformMenuPrincipal.NotifyTray(Command: Word; const Hint: string);
var
  Data: TNotifyIconData;
begin
  Data.cbSize := SizeOf(Data);
  Data.uID := 0;
  Data.uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
  Data.Wnd := Self.Handle;
  Data.uCallbackMessage := FTrayMessage;
  Data.hIcon := Application.Icon.Handle;
  StrLCopy(Data.szTip, PChar(Hint), SizeOf(Data.szTip));
  Shell_NotifyIcon(Command, @Data);
end;

procedure TformMenuPrincipal.WndProc(var Msg: TMessage);
begin
  if Msg.Msg = FTrayMessage then
    case Msg.LParam of
      WM_RBUTTONUP: RButtonUp;
      WM_LBUTTONDBLCLK: LButtonDblClk;
    end
  else
    inherited WndProc(Msg);
end;

procedure TformMenuPrincipal.RButtonUp;
var
  Pt: TPoint;
begin
  GetCursorPos(Pt);
  SetForegroundWindow(Application.Handle);
  Application.ProcessMessages;
  PopupMenu1.Popup(Pt.X, Pt.Y);
end;

procedure TformMenuPrincipal.LButtonDblClk;
begin
  mnuMostrarClick(nil);
end;

procedure TformMenuPrincipal.THoraTimer(Sender: TObject);
begin
  LHora.Caption := TimeToStr(time);
end;

procedure TformMenuPrincipal.BNuevoClick(Sender: TObject);
var
  precio : string;
  precioNum : double;
begin
  if txtProgramas.Text <> '' then
  begin
    if leCadINI (txtProgramas.Text, 'Activo', '') <> '' then
    begin
      showmessage ('El programa ya existe en la lista.');
      txtProgramas.SetFocus;
    end
    else
    begin
      esCadINI(txtProgramas.Text, 'Activo', 'N');
      esFechaINI(txtProgramas.Text, 'Fecha inicio', Date);
      precio := inputbox ('Precio hora...', 'Introduce el precio hora para el nuevo programa:', '20');
      if precio <> '' then
      begin
        try
          precioNum := strtofloat (precio);
        except
          showMessage ('El precio introducido no es un nmero correcto. Pulse "Precio" para volver a intentarlo.');
          precioNum := 0;
        end;
      end
      else
        precioNum := 0;
      esFloatINI(txtProgramas.Text, 'Precio Hora', precioNum);
    end;
    insertarElementosLista;
  end
  else
  begin
    ShowMessage('Debe introducir un nombre para el programa.');
    txtProgramas.SetFocus;
  end;
end;

procedure TformMenuPrincipal.BCerrarClick(Sender: TObject);
begin
  close;
end;

procedure TformMenuPrincipal.BIniciarClick(Sender: TObject);
begin
  if txtProgramas.Text <> '' then
  begin
    if leCadINI (txtProgramas.Text, 'Activo', '') = 'N' then
    begin
      esCadINI(txtProgramas.Text, 'Activo', 'S');
      esFechaINI(txtProgramas.Text, 'Fecha inicio', date);
      esHoraINI(txtProgramas.Text, 'Hora inicio', Time);
      esFloatINI(txtProgramas.Text, 'Inicio temporizador', GetTickCount());
    end
    else
    begin
      if leCadINI (txtProgramas.Text, 'Activo', '') = '' then
        showmessage ('El programa no existe, adalo primero.')
      else
        showmessage ('El programa ya ha sido iniciado a las: ' +
            TimeToStr(leHoraINI(txtProgramas.Text, 'Hora inicio', time)));
    end;
  end
  else
  begin
    showmessage ('Debe seleccionar un programa.');
    txtProgramas.SetFocus;
  end;
end;

procedure TformMenuPrincipal.BPararClick(Sender: TObject);
var
  minutos : double;
  tiempo : double;
  fin : double;
begin
  if txtProgramas.Text <> '' then
  begin
    if not (leCadINI(txtProgramas.Text, 'Activo', '') = 'N') then
    begin
      //horaInicio := leHoraINI(txtProgramas.Text, 'Hora inicio', Time);
      minutos := lefloatINI(txtProgramas.Text, 'Minutos', 0);
      fin := gettickcount ();
      tiempo := fin -
          leFloatINI(txtProgramas.Text, 'Inicio temporizador', 0);
      tiempo := tiempo / 1000; //segundos
      esFloatINI(txtProgramas.Text, 'Fin temporizador', fin);
      esHoraINI(txtProgramas.Text, 'Hora fin', time);
      minutos := minutos + (tiempo / 60);
      esfloatINI(txtProgramas.Text, 'Minutos', minutos);
      esCadINI(txtProgramas.Text, 'Activo', 'N');
    end
    else
      ShowMessage ('El programa ya ha sido parado a las ' +
          timetostr(leHoraINI(txtProgramas.Text, 'Hora fin', time)));
  end
  else
  begin
    showmessage ('Debe seleccionar un programa.');
    txtProgramas.SetFocus;
  end;
end;

function TFormMenuPrincipal.eliminado (programa : string) : boolean;
begin
 result := leCadINI(programa, 'Activo', '') = '';
end;

procedure TformMenuPrincipal.BInformeClick(Sender: TObject);
var
  minutos, horas, precio : double;
begin
  txtInforme.Clear;
  if txtProgramas.Text <> '' then
  begin
    if not eliminado (txtProgramas.Text) then
    begin
      precio := leFloatINI (txtProgramas.Text, 'Precio Hora', 0);
      txtInforme.Lines.Add('Programa: ' + txtProgramas.Text);
      txtInforme.Lines.Add('Precio Hora: ' + floattostr(precio));
      minutos := lefloatINI(txtProgramas.Text, 'Minutos', 0);
      horas := minutos / 60;
      if horas >= 1 then
        txtInforme.Lines.Add('Horas: ' + floattostr(horas))
      else
        txtInforme.Lines.Add('Minutos: ' + floattostr(minutos));
      txtInforme.Lines.Add('Importe: ' + floattostr(precio * horas));
      Height := 201;  
    end
    else
      showmessage ('El programa no existe o ha sido eliminado.');
  end
  else
    ShowMessage('Debe seleccionar un programa.');
end;

procedure TformMenuPrincipal.BEliminarClick(Sender: TObject);
begin
  if txtProgramas.Text <> '' then
  begin
    if leCadINI(txtProgramas.Text, 'Activo', '') <> '' then
      esCadINI(txtProgramas.Text, 'Activo', '')
    else
      showmessage ('El programa no existe o ya ha sido eliminado.');
  end
  else
    ShowMessage('Debe seleccionar un programa.');
end;

procedure TformMenuPrincipal.mnuPonerEncimaClick(Sender: TObject);
begin
  if FormStyle = fsStayOnTop then
    FormStyle := fsNormal
  else
    FormStyle := fsStayOnTop;
  mnuPonerEncima.Checked := not mnuPonerEncima.Checked;
end;

procedure TformMenuPrincipal.FormDestroy(Sender: TObject);
begin
  NotifyTray(NIM_DELETE, '');
end;

procedure TformMenuPrincipal.mnuOcultarClick(Sender: TObject);
begin
  THora.Enabled := false; 
  hide;
  mnuOcultar.visible := false;
  mnuMostrar.visible := true;
  mnuPonerEncima.Visible := false;
  Application.ShowMainForm := False;
  ShowWindow(Application.Handle, SW_HIDE);
  FTrayMessage := RegisterWindowMessage(PChar(STrayMessage));
  NotifyTray(NIM_ADD, 'TemPro (por AlonSoft)')
end;

procedure TformMenuPrincipal.mnuMostrarClick(Sender: TObject);
begin
  THora.Enabled := true;
  show;
  mnuOcultar.Visible := true;
  mnuPonerEncima.Visible := true;
  mnuMostrar.Visible := false;
  NotifyTray(NIM_DELETE, '');
end;

procedure TformMenuPrincipal.BPrecioClick(Sender: TObject);
var
  precio : string;
  precioNum : double;
begin
  if txtProgramas.Text <> '' then
  begin
    if leCadINI(txtProgramas.Text, 'Activo', '') <> '' then
    begin
      precioNum := leFloatINI (txtProgramas.Text, 'Precio Hora', 0);
      precio := inputbox ('Precio hora...', 'Introduce el precio hora para el programa:', floattostr(precioNum));
      if precio <> '' then
      begin
        try
          precioNum := strtofloat (precio);
        except
          showMessage ('El precio introducido no es un nmero correcto. Pulse "Precio" para volver a intentarlo.');
          exit;
        end;
      end
      else
        precioNum := 0;
      esFloatINI(txtProgramas.Text, 'Precio Hora', precioNum);
    end
    else
      showmessage ('El programa no existe o ya ha sido eliminado.');
  end
  else
  begin
    showmessage ('Debe seleccionar un programa.');
    txtProgramas.SetFocus;
  end;
end;

procedure TformMenuPrincipal.BOcultarClick(Sender: TObject);
begin
  Height := 73;
end;

procedure TformMenuPrincipal.FormCreate(Sender: TObject);
begin
  insertarElementosLista;
  Height := 93;
end;

procedure TformMenuPrincipal.BGuardarClick(Sender: TObject);
begin
  if dlgGuardar.Execute then
    txtInforme.Lines.SaveToFile(dlgGuardar.FileName);
end;

procedure TformMenuPrincipal.LWEBClick2(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar(LWEB.CAPTION),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.
