unit UnidadProcedimientos;

interface

uses classes, dbierrs, dbtables, SysUtils, Windows, Messages, Variants, Controls,
  Dialogs, ExtCtrls,  inifiles;

  function pMes (mes : word) : string;
  function pFecha (dia, mes, ano : word) : tdate;
  function reemplazarTexto (cadena, textoAReemplazar, textoNuevo : string) : string;
  function Redondear (Numero : Double; PrecisionDec : byte) : double;
  function leBoolINI (clave, cadena : string; defecto : boolean) : boolean;
  function leEntINI (clave, cadena : string; defecto : integer) : integer;
  function leCadINI (clave, cadena : string; defecto : string) : string;
  procedure esBoolINI (clave, cadena : string; valor : boolean);
  procedure esEntINI (clave, cadena : string; valor : integer);
  procedure esCadINI (clave, cadena, valor : string);
  procedure esFloatINI (clave, cadena : string; valor : double);
  procedure esFechaINI (clave, cadena : string; defecto : tdatetime);
  procedure esHoraINI (clave, cadena : string; defecto : ttime);
  function leFechaINI (clave, cadena : string; defecto : tdatetime) : tdatetime;
  function leHoraINI (clave, cadena : string; defecto : ttime) : ttime;
  function leFloatINI (clave, cadena : string; defecto : double) : double;

implementation


function leBoolINI (clave, cadena : string; defecto : boolean) : boolean;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := readbool (clave, cadena, defecto);
  finally
    free;
  end;
end;

function leEntINI (clave, cadena : string; defecto : integer) : integer;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := readInteger (clave, cadena, defecto);
  finally
    free;
  end;
end;

function leCadINI (clave, cadena : string; defecto : string) : string;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := readString (clave, cadena, defecto);
  finally
    free;
  end;
end;

procedure esBoolINI (clave, cadena : string; valor : boolean);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    writeBool (clave, cadena, valor);
  finally
    free;
  end;
end;

procedure esEntINI (clave, cadena : string; valor : integer);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    writeInteger (clave, cadena, valor);
  finally
    free;
  end;
end;

procedure esCadINI (clave, cadena, valor : string);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    writeString (clave, cadena, valor);
  finally
    free;
  end;
end;

procedure esFloatINI (clave, cadena : string; valor : double);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    WriteFloat (clave, cadena, valor);
  finally
    free;
  end;
end;

procedure esFechaINI (clave, cadena : string; defecto : tdatetime);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    WriteDate (clave, cadena, defecto);
  finally
    free;
  end;
end;

procedure esHoraINI (clave, cadena : string; defecto : ttime);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    WriteTime (clave, cadena, defecto);
  finally
    free;
  end;
end;

function leFechaINI (clave, cadena : string; defecto : tdatetime) : tdatetime;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := ReadDate (clave, cadena, defecto);
  finally
    free;
  end;
end;

function leHoraINI (clave, cadena : string; defecto : ttime) : ttime;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := ReadTime (clave, cadena, defecto);
  finally
    free;
  end;
end;

function leFloatINI (clave, cadena : string; defecto : double) : double;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := readfloat (clave, cadena, defecto);
  finally
    free;
  end;
end;


function Redondear (Numero : Double; PrecisionDec : byte) : double;
  function Potencia(Base : Double; Exponente : byte) : Double;
  begin
    Result := Exp(Exponente * ln(Base));
  end;
begin
  result := Round(Numero * Potencia(10, PrecisionDec)) / Potencia (10, PrecisionDec);
end;


//Comprueba si la aplicacin est ejecutndose ya
function ejecutadaYa (nombreAplicacion : string) : boolean;
var
  MiMutex : Thandle;
begin
  mimutex := CreateMutex(nil, true, pchar(nombreAplicacion));
  if MiMutex = 0 then
    result := false
  else
  begin
    if GetLastError = ERROR_ALREADY_EXISTS then
      result := true
    else
      result := false;
  end;
end;


//Devuelve la fecha a partir de da, mes, ao
function pFecha (dia, mes, ano : word) : tdate;
begin
  result := EncodeDate (ano,mes,dia);
end;


//Devuelve el nombre del mes segn el nmero
function pMes (mes : word) : string;
begin
  case mes of
    1 : result := 'Enero';
    2 : result := 'Febrero';
    3 : result := 'Marzo';
    4 : result := 'Abril';
    5 : result := 'Mayo';
    6 : result := 'Junio';
    7 : result := 'Julio';
    8 : result := 'Agosto';
    9 : result := 'Septiembre';
    10 : result := 'Octubre';
    11 : result := 'Noviembre';
    12 : result := 'Diciembre';
  end;
end;


function reemplazarTexto (cadena, textoAReemplazar, textoNuevo : string) : string;
var
  aPos : Integer;
begin
  aPos := Pos(textoAReemplazar, Cadena);
  Result := '';
  while (aPos <> 0) do begin
    Result := Result + Copy(Cadena, 1, aPos - 1) + textoNuevo;
    Delete(Cadena, 1, aPos + Length(textoAReemplazar) - 1);
    aPos := Pos(textoAReemplazar, Cadena);
  end;
  Result := Result + Cadena;
end;


end.
